class BindInfo {
  int result;
  int code;
  String msg;
  BindInfoData data;

  BindInfo({this.result, this.code, this.msg, this.data});

  BindInfo.fromJson(Map<String, dynamic> json) {
    result = json['result'];
    code = json['code'];
    msg = json['msg'];
    data =
        json['data'] != null ? new BindInfoData.fromJson(json['data']) : null;
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['result'] = this.result;
    data['code'] = this.code;
    data['msg'] = this.msg;
    if (this.data != null) {
      data['data'] = this.data.toJson();
    }
    return data;
  }
}

class BindInfoData {
  bool password;
  String phone;
  bool weixin;
  bool qq;

  BindInfoData({this.password, this.phone, this.weixin, this.qq});

  BindInfoData.fromJson(Map<String, dynamic> json) {
    password = json['password'];
    phone = json['phone'];
    weixin = json['weixin'];
    qq = json['qq'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['password'] = this.password;
    data['phone'] = this.phone;
    data['weixin'] = this.weixin;
    data['qq'] = this.qq;
    return data;
  }
}
